#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h> 
#include <arpa/inet.h>
#include "select_value.c"


#define HEADSIZE 256
#define BUFSIZE HEADSIZE+256
#define FNAME_CONFIG "clientR.config"

#define PRINT 0

#include "code_pass.c"




//timer
#include <time.h>
struct timespec t_start, t_stop;

int start_time(void) {
 return clock_gettime(CLOCK_REALTIME, &t_start);
}

int stop_time(void) {
 return clock_gettime(CLOCK_REALTIME, &t_stop);
}

void dif_t( int ret) {
   //time_t s;
   double s;
  s = 1.0*t_stop.tv_sec + 1.0*t_stop.tv_nsec/(1000.0*1000.0*1000.0) - (1.0*t_start.tv_sec + 1.0*t_start.tv_nsec/(1000.0*1000.0*1000.0));
  //ns = 1.0*t_stop.tv_nsec - t_start.tv_nsec-370549;
  //if(ns < 0) {ns = 0;}
  //if(ret && ns!=0) 
  printf("time: %3.3f [s]\n", s );

}




//--- init table ---
char matrix_client[256][40];


void error(const char*msg)
{
    if(PRINT) perror(msg);
    //exit(1);
}

int code_socket(const char*ip_address, int portno, char*message)
{
    int sockfd, n;
    struct sockaddr_in serv_addr;

    //char*ip_address ="10.0.0.4";

    char buffer[BUFSIZE];
    char txt [BUFSIZE];

    //portno = 9501;

    sockfd = socket(AF_INET, SOCK_STREAM, 0);

    if (sockfd < 0) {
        error("ERROR");
        return -1;
    }
 
    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_addr.s_addr = inet_addr(ip_address);
    serv_addr.sin_port = htons(portno);

   if (connect(sockfd,(struct sockaddr *) &serv_addr,sizeof(serv_addr)) < 0) { 
        error("ERROR");
        return -1;
   }


    memset(buffer,0, BUFSIZE);
    //strcpy(buffer,message);
    memcpy(txt, message, strlen(message)+1);

//clock_gettime(CLOCK_REALTIME, &t_start);//<---- start time

    codeV1(txt, 0, buffer);

//printf("SEND: %s\n",txt);
clock_gettime(CLOCK_REALTIME, &t_start);//<---- start time

    n = write(sockfd, buffer, BUFSIZE);
    if(n < 0) {
         error("ERROR");
         return -1;
    }
    //printf("mesage written\n");
    memset(buffer,0, BUFSIZE);
    //n = read(sockfd,buffer, BUFSIZE);
    n = recv(sockfd,buffer, BUFSIZE,0);
    if(n < 0)  {
         error("ERROR");
         return -1;
    }
clock_gettime(CLOCK_REALTIME, &t_stop);//<----- stop timer
dif_t(1);// <---- print tme

    //printf("RECV: %s\n",buffer);

    if(strcmp(buffer,"I love you.")==0) {
       strcpy(txt,buffer);
    } else decodeV1(buffer,0, txt);

    //printf("RECV: %s\n",txt);
    strcpy(message, txt);

    close(sockfd);

    //printf("[%d] blocks of %d bytes has been sent\n",i, BUFSIZE);

    return 0;
}



// --- init table ---
int init_driver(const char*fname_config) {

   int i;

   FILE*fd = fopen(fname_config, "r");
   if(fd==NULL) { 
       error("ERROR");
       exit(1);
       }

   char*st = (char*)malloc(80*sizeof(char));
   if(st==NULL) {
      fclose(fd);
      error("ERROR");
   }
   strcpy(matrix_client[0],"null");
   i=1;
   while(fgets(st,80,fd)!=NULL && i<12) {
      strcpy(matrix_client[i], st);
      i++;
   }
   fclose(fd);
   free(st);
   return 0;
}


//--- select parametres of connection with meserverR ---
void select_addr(int pump_nr, char*ip_addr, int*port) {
   char st[40];
   select_value(matrix_client[pump_nr],"IPADDR",st);
   if(strcmp(st,"NULL")!=0) strcpy(ip_addr, st);
   else strcpy(ip_addr,"null");

   //printf("IP: %s\n", ip_addr);


   select_value(matrix_client[pump_nr],"PORT",st);
   if(strcmp(st,"NULL")!=0) {
      *port = atoi(st);
   }
   else *port = 0;

}


// --- to/from mserveR ---
// H00:	    TEST=H00&				test mserverR
// version: OP=version&				software version
// time:    OP=timeprec&			time in mserverR(Q,P)
// size:    OP=currentspace&PUMP=<nr pump>&	free size ACCOUNTS & ACCONTS1
// start:   OP=startserver&PUMP=<nr pump>&	start system pumps
// stop:    OP=stopserver&PUMP=<nr pump>&	stop system pumps
// status:  OP=pumpstatus&			system status
// shut:    OP=shutdown& (before do stopserver)	shutdown server after 5s
// reboot:  OP=reboot&
// ntpd:    0P=restartntpd&			restarts ntpd daemon
int op_message(int pump_nr, const char*op, char*out) {
   char ip[20];
   int port;
   char msg[BUFSIZE];
   char st[80];
   
   if(pump_nr>255) return 0; //256 max available nr nodes in LAN

   //init system parameters <------------
   init_driver(FNAME_CONFIG);

   //chg nr pump into ip addr and   port
   select_addr(pump_nr, ip, &port);
   if(port==0) {
      strcpy(out,"null");
      return 0;
   }


//---------------> test <------------------------------
//printf("PUMP: %d, IP=%s, PORT=%d\n", pump_nr, ip, port);



   //--- test H00 ---
   if(strcmp(op,"H00")==0) {
     strcpy(msg, "TEST=H00&");
     code_socket(ip, port, msg);
     select_value(msg, "SN", st);
     strcpy(out,"IP=");strcat(out,ip);
     strcat(out,"\tPORT=");
     sprintf(msg,"%d", port);
     strcat(out,msg); strcat(out,"\tSERVER-NR: ");
     strcat(out,st);
     if(strcmp(st,"NULL")!=0) return 1;
     return 0;
   }

   // --- version ---
   // retruns nr of version mserverR
   if(strcmp(op,"version")==0) {
     strcpy(msg,"OP=version&");
     code_socket(ip, port, msg);
     select_value(msg,"NR", st);
     strcpy(out,st);
     if(strcmp(st,"NULL")!=0) return 1; 
     return 0;
   }  

   // --- time ---
   //returns TIME=<seconds>
   //        NANO=<nano seconds>
   if(strcmp(op,"time")==0) {
     strcpy(msg,"OP=timeprec&");
     code_socket(ip, port, msg);
     select_value(msg,"TIME",st);
     strcpy(out, "PUMP TIME: "); 
     strcat(out,st);
     strcat(out, "[s], ");
     select_value(msg, "NANO", st);
     strcat(out, st);
     strcat(out, "[ns]");		
     if(strcmp(st,"NULL")!=0) return 1;
     return 0;
   } 

   // --- size ---
   //return ACCOUNTS=<free size on HDD>
   //       ACCOUNTS1=<free size on HDD>
   if(strcmp(op,"size")==0) {
     strcpy(msg,"OP=currentspace&PUMP=");
     sprintf(st, "%d", pump_nr);
     strcat(msg,st);
     strcat(msg,"&");
     code_socket(ip, port, msg);
     select_value(msg,"STATUS",st);
     if(strcmp(st,"done")==0) {
        strcpy(out,msg);
        return 1;
     }
     strcpy(out,"NULL");
     return 0;
   }    
  
   // --- start ---
   // returns status onf/off
   if(strcmp(op,"start")==0) {
     //stop pumps (clears if one pump is working)
     strcpy(msg,"OP=stopserver&PUMP=");
     sprintf(st, "%d", pump_nr);
     strcat(msg,st);
     strcat(msg,"&");
     code_socket(ip, port, msg);
     //start pumps
     strcpy(msg,"OP=startserver&PUMP=");
     sprintf(st, "%d", pump_nr);
     strcat(msg,st);
     strcat(msg,"&");
     code_socket(ip, port, msg);
     select_value(msg,"STATUS",st);
     if(strcmp(st,"done")==0) {
        strcpy(msg,"OP=pumpstatus&");
        code_socket(ip, port, msg);
        strcpy(out,msg);
        return 1;
     }
     strcpy(msg,"OP=pumpstatus&");
     code_socket(ip, port, msg);
     strcpy(out,msg);
     return 0;
   }      

   // --- stop ---
   // returns status on/off
   if(strcmp(op,"stop")==0) {
     strcpy(msg,"OP=stopserver&PUMP=");
     sprintf(st, "%d", pump_nr);
     strcat(msg,st);
     strcat(msg,"&");
     code_socket(ip, port, msg);
     select_value(msg,"STATUS",st);
     if(strcmp(st,"done")==0) {
        strcpy(msg,"OP=pumpstatus&");
        code_socket(ip, port, msg);
        strcpy(out,msg);
        return 1;
     }
     strcpy(msg,"OP=pumpstatus&");
     code_socket(ip, port, msg);
     strcpy(out,msg);
     return 0;
   } 

   // --- status ---
   //returns status on/off
   if(strcmp(op,"status")==0) {
     strcpy(msg,"OP=pumpstatus&");
     code_socket(ip, port, msg);
     select_value(msg,"RE", st);
     if(strcmp(st,"NULL")!=0) {
        strcpy(out,msg);
        return 1;
     }
     strcpy(out,st);
     return 0;
   } 

   // --- shutdown server ---
   // stop mservers and shutdown server
   if(strcmp(op,"shutdown")==0) {
     strcpy(msg,"OP=stopserver&PUMP=");
     sprintf(st, "%d", pump_nr);
     strcat(msg,st);
     strcat(msg,"&");
     code_socket(ip, port, msg);
     select_value(msg,"STATUS",st);
     if(strcmp(st,"done")==0) {
        strcpy(msg,"OP=shutdown&");
        code_socket(ip, port, msg);
        select_value(msg, "STATUS", st);
        if(strcmp(st,"done")==0) {
            strcpy(out,"ok.");
            return 1;
        }
        strcpy(out,"shutdown after 5");
        return 0;
     }
     strcpy(out,"Error&");
     return 0;
   }

   // --- reboot server ---
   // stop mservers and shutdown server
   if(strcmp(op,"reboot")==0) {
     strcpy(msg,"OP=stopserver&PUMP=");
     sprintf(st, "%d", pump_nr);
     strcat(msg,st);
     strcat(msg,"&");
     code_socket(ip, port, msg);
     select_value(msg,"STATUS",st);
     if(strcmp(st,"done")==0) {
        strcpy(msg,"OP=reboot&");
        code_socket(ip, port, msg);
        select_value(msg, "STATUS", st);

        	if(strcmp(st,"done")==0) {
            		strcpy(out,"ok.");
            	return 1;
        	}
        	strcpy(out,"reboot after 5s");
        	return 0;
     }
     strcpy(out,"Error&");
     return 0;
   }

   // --- restart ntpd daemon ---
   if(strcmp(op,"restartntpd")==0) {
        strcpy(msg,"OP=restartntpd&");
        code_socket(ip, port, msg);
        select_value(msg, "STATUS", st);
           if(strcmp(st,"done")==0) {
                strcpy(out,"ok.");
            	return 1;
           }
           strcpy(out,"Error&");
           return 0;
     }


   // --- start UIDL ---
   if(strcmp(op,"start_UIDL")==0) {
        strcpy(msg,"OP=start_UIDL&");
        code_socket(ip, port, msg);
//printf("MSG: %s\n", msg);
        select_value(msg, "STATUS", st);
           if(strcmp(st,"done")==0) {
                strcpy(out,"ok.");
            	return 1;
           }
           strcpy(out,"Error&");
           return 0;
     }

   // --- stop UIDL ---
   if(strcmp(op,"stop_UIDL")==0) {
        strcpy(msg,"OP=stop_UIDL&");
        code_socket(ip, port, msg);
printf("MSG: %s\n", msg);
        select_value(msg, "STATUS", st);
           if(strcmp(st,"done")==0) {
                strcpy(out,"ok.");
            	return 1;
           }
           strcpy(out,"Error&");
           return 0;
     }


   // --- status UIDL ---
   if(strcmp(op,"status_UIDL")==0) {

        strcpy(msg,"OP=status_UIDL&");
        code_socket(ip, port, msg);
        select_value(msg, "SERVER", st);

	if(strcmp(st, "NULL") == 0) {
		strcpy(out,"Error&");
		return 0;
	}
        if(strcmp(st,"active")==0) strcpy(out,"UILD: active ");
	   else	strcpy(out, "UIDL: stopped ");

	select_value(msg, "MYIP", st);
		if(strcmp(st, "active") == 0) strcat(out, "MYIP: active");
		else strcat(out, "MYIP: stopped");

        return 1;
     }



   strcpy(out,"null");
   return 0;  
}







/*
int main() {

int i;

//pompy liczone sa od 1 do n
char out[HEADSIZE];
for(i=1; i<255;i++) {
   if(op_message(i, "H00", out)) {
     //printf("out: %s\n", out);
     printf("Start srevers in node#%d, wait a moment ...\n",i);
     op_message(i, "start", out);
    printf("%s\n", out);
   }
}
return 0;
}*/
