#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <termios.h>
#include <pthread.h>

#include "clientR.c"


#define NR_NODES 256


//definiuje ANSI kolory w printf
#define BOLDBLACK   "\033[1m\033[30m"
#define BOLDRED     "\033[1m\033[31m"
#define BOLDBLUE    "\033[1m\033[34m"
#define RED     	"\x1b[31m"
#define GREEN   	"\x1b[32m"
#define YELLOW  	"\x1b[33m"
#define BLUE    	"\x1b[34m"
#define MAGENTA 	"\x1b[35m"
#define CYAN    	"\x1b[36m"
#define COLOR_RESET   	"\x1b[0m"
     

//printf errors
int test = 1;









///////////////////////////////////////////////////////////////////////////////
//-------------------------------- PRESS KEY ----------------------------------
///////////////////////////////////////////////////////////////////////////////
 //reaguje na przycisniecie klawisza wyboru
//bez 'echo" oraz zwraca key code asci
int getch(void)
{
    struct termios oldattr, newattr;
    int ch;
    tcgetattr( STDIN_FILENO, &oldattr );
    newattr = oldattr;
    newattr.c_lflag &= ~( ICANON | ECHO );
    tcsetattr( STDIN_FILENO, TCSANOW, &newattr );
    ch = getchar();
    tcsetattr( STDIN_FILENO, TCSANOW, &oldattr );
    return ch;
}


//SPECJALNE: tylko arrows left/right/down/up
//jesli przycisniete sa strzalki (up,down,right,left)
//zwraca kod jesli nie jest to arrow
//jesli jest arrow to zwraca 0; jak byl inny znak to 
int getch_arrows(char*arrow) {
	int j=0;
	int ret=-1; 
	char key[3];
	if((ret=getch())==27); else return ret;
	while(j<2){
		key[j]= getch();j++;
		}
	if(key[0]==91 && key[1]==65) {strcpy(arrow,"u"); return 0;}//up
	if(key[0]==91 && key[1]==66) {strcpy(arrow,"d"); return 0;}//down
	if(key[0]==91 && key[1]==67) {strcpy(arrow,"r"); return 0;}//right
	if(key[0]==91 && key[1]==68) {strcpy(arrow,"l"); return 0;}//left
   return -1;
}
///////////////////////////////////////////////////////////////////////////////
//---------------------------- END PRESS KEY ----------------------------------
///////////////////////////////////////////////////////////////////////////////






///////////////////////////////////////////////////////////////////////////////
//---------------------------- Graphic overlay --------------------------------
///////////////////////////////////////////////////////////////////////////////

//test all servers
int start_point(void) {
	int ch;
    while(1) {
	system("clear");
     printf("==================================================================\n");
     printf("                         Tests of the system\n");
     printf("==================================================================\n");
     printf("  [1] --> Test H00\n"); 
     printf("  [2] --> Test servers status\n");
     printf("  [3] --> Start servers\n");
     printf("  [4] --> Stop servers\n");
     printf("  [5] --> Reboot servers\n");
     printf("  [6] --> Shutdown servers\n");
     printf("  [7] --> Start UIDL\n");
     printf("  [8] --> Stop UIDL\n");
     printf("  [9] --> Status UIDL\n\n");


     printf("  [i] --> One server tests\n\n");
     printf("  [q] --> quit\n");
     printf("==================================================================\n");
     printf("Wybierz opcje: ");
	ch = getch();
	printf("\n");
	
	if(ch=='1') return 1;
	if(ch=='2') return 2;
	if(ch=='3') return 3;
	if(ch=='4') return 4;
	if(ch=='5') return 5;
	if(ch=='6') return 6;
	if(ch=='7') return 7;
	if(ch=='8') return 8;
	if(ch=='9') return 9;




	if(ch=='i' || ch=='I')  return -1; //individual test
	if(ch=='q' || ch=='Q')  return 0;	
	
   }//while
}

//tests of selected server
int one_server_test(void) {
	int ch;
    while(1) {
	system("clear");
     printf("==================================================================\n");
     printf("                         One server test\n");
     printf("==================================================================\n");
     printf("  [1] --> Test H00\n"); 
     printf("  [2] --> Test server status\n");
     printf("  [3] --> Start server\n");
     printf("  [4] --> Stop server\n");
     printf("  [5] --> Reboot server\n");
     printf("  [6] --> Shutdown server\n");
     printf("  [7] --> Version\n");
     printf("  [8] --> Current time\n");
     printf("  [9] --> Free Space\n\n");

     printf("  [n] --> Restart ntpd daemon\n\n");

     printf("  [q] --> quit\n");
     printf("==================================================================\n");
     printf("Wybierz opcje: ");
	ch = getch();
	printf("\n");
	
	if(ch=='1') return 1;
	if(ch=='2') return 2;
	if(ch=='3') return 3;
	if(ch=='4') return 4;
	if(ch=='5') return 5;
	if(ch=='6') return 6;
	if(ch=='7') return 7;
	if(ch=='8') return 8;
	if(ch=='9') return 9;
        if(ch=='n') return 10;

	if(ch=='q' || ch=='Q')  return 0;	
	
   }//while
}

//the table show result of test
//RE=pumpstatus&PP=<on/off>&PQ=<on/off>&NTP=<on/off>&SSH=<on/off>PS=<on/off>&WD=<on/onf>&ST=<on/off>&
/*
   PP: mserverP
   PQ: mserverQ
   NTP: ntpd
   SSH: sshd
   PS: ssh_passwd
   WD: watch-dog-PUMP
   ST: sync_time 
   */
void show_status(int pump_nr, const char*input) {
   char st[80];
   char pp[4];
   char pq[4];
   char ntp[4];
   char ssh[4];
   char ps[4];
   char wd[4];


   select_value(input, "RE", st);

   //pumps status
   if(strcmp(st,"pumpstatus")==0) {
      select_value(input,"PP",pp);
      select_value(input,"PQ",pq);
      select_value(input,"NTP",ntp);
      select_value(input,"SSH",ssh);
      select_value(input,"PS",ps);
      select_value(input,"WD",wd);
      select_value(input,"ST",st);

      printf("-------------------------------------------------------------------------\n");
      printf("PUMP #%d\n", pump_nr);
      printf("[P:%s] [Q:%s] [ntp:%s] [ssh:%s] [passwd:%s] [wdog:%s] [sync:%s]\n",
       pp,pq,ntp,ssh,ps,wd,st);
      printf("-------------------------------------------------------------------------\n");
      return;
   }
  
   //free space
   if(strcmp(st,"currentspace")==0) {
      select_value(input, "STATUS", st);
      if(strcmp(st,"refused")==0) {
         printf(" PUMP NR %d: can't read data network\n", pump_nr);
         return;
      }
      select_value(input,"ACCOUNTS", st);
      printf(" PUMP NR %d  | ACCOUNTS:  %s ", pump_nr, st);
      select_value(input,"ACCOUNTS1",st);
      printf("|  ACCOUNTS1: %s  |\n", st);
      return;
   }
  
    printf(RED "No reply from data network\n"COLOR_RESET);

}
///////////////////////////////////////////////////////////////////////////////
//----------------------------END Graphic overlay -----------------------------
///////////////////////////////////////////////////////////////////////////////






///////////////////////////////////////////////////////////////////////////////
//--------------------------------- Functions  --------------------------------
///////////////////////////////////////////////////////////////////////////////

//--- tests all pumps ----
int op_all_data_network(void) {

   int ch;
   int i;
   char out[80];

   ch = start_point();

 //printf("--> ch=%d\n", ch);

   //test H00 all
   if(ch==1) {
      printf("Test servers presence\n");
      for(i=1; i<255;i++) {
         if(op_message(i, "H00", out)) printf("%s\n", out);
      }
   return 1;
   }

   //status all
   if(ch==2) {
      printf("Status servers\n");
      for(i=1; i<255;i++) {
         if(op_message(i, "H00", out)) {
           op_message(i, "status", out);
           show_status(i, out);
         }
      }
   return 2;
   }

   //start all
   if(ch==3) {
      for(i=1; i<255;i++) {
         if(op_message(i, "H00", out)) {
            printf("Start servers in node#%d, wait a moment ...\n",i);
            op_message(i, "start", out);
            show_status(i, out);
         }
      }
   return 3;
   }

   //stop all
   if(ch==4) {
      for(i=1; i<255;i++) {
         if(op_message(i, "H00", out)) {
            printf("Stop servers in node#%d, wait a moment ...\n",i);
            op_message(i, "stop", out);
            show_status(i, out);
         }
      }
   return 4;
   }

   //reboot all nodes
   if(ch==5) {
      for(i=1; i<255;i++) {
         if(op_message(i, "H00", out)) {
            printf("Reboot node#%d\n",i);
            op_message(i, "reboot", out);
            printf("Node#%d, status: %s\n", i, out);
         }
      }
   return 5;
   }

   //shudown all nodes
   if(ch==6) {
      for(i=1; i<255;i++) {
         if(op_message(i, "H00", out)) {
            printf("Shutdown node#%d\n",i);
            op_message(i, "shutdown", out);
            printf("Node#%d, status: %s\n", i, out);
         }
      }
   return 6;
   }

	//start_UIDL
   if(ch==7) {
      printf("start_UIDL\n");
      if(op_message(1, "start_UIDL", out)) {
         printf("%s\n", out);
         return 1;
      }
      else printf(" Node status: off\n");
   return 0;
   }

	//stop_UIDL
  	if(ch==8) {
      printf("stop_UIDL\n");
      if(op_message(1, "stop_UIDL", out)) {
         printf("%s\n", out);
         return 1;
      }
      else printf(" Node status: off\n");
   return 0;
   }

	//status_UIDL
  	if(ch==9) {
      printf("status_UIDL\n");
      if(op_message(1, "status_UIDL", out)) {
         printf("%s\n", out);
         return 1;
      }
      else printf(" Node status: off\n");
   return 0;
   }


	

   return ch;
}


//--- test one node ---
int op_one_node(int nr_node) {

   int ch;
   char out[80];
 
   ch = one_server_test();

   if(ch==0)  return 0;

   //H00
   if(ch==1) {
      printf("Test H00\n");
      if(op_message(nr_node, "H00", out)) {
         printf("Nr: %d,\t %s\n", nr_node, out);
         return 1;
      }
      else printf(" Node status: off\n");
   return 0;
   }

   //status
   if(ch==2) {
      printf("Status server #%d\n", nr_node);
         if(op_message(nr_node, "H00", out)) {
           op_message(nr_node, "status", out);
           show_status(nr_node, out);
           return 1;
         }
      else printf(" Node status: off\n");
   return 0;
   }

   //start mservers
   if(ch==3) {
         printf("Start servers in node#%d, wait a moment ...\n",nr_node);
         if(op_message(nr_node, "H00", out)) {
            op_message(nr_node, "start", out);
            show_status(nr_node, out);
            return 1;
         }
      else printf(" Node status: off\n");
   return 0;   
   }

   //stop mservers
   if(ch==4) {
         printf("Stop servers in node#%d, wait a moment ...\n",nr_node);
         if(op_message(nr_node, "H00", out)) {
            op_message(nr_node, "stop", out);
            show_status(nr_node, out);
            return 1;
         }
      else printf(" Node status: off\n");
   return 0; 
   }
   
   //reboot node
   if(ch==5) {
         printf("Reboot node#%d\n", nr_node);
         if(op_message(nr_node, "H00", out)) {
            op_message(nr_node, "reboot", out);
            printf("Node#%d, status: %s\n", nr_node, out);
            return 1;
         }
      else printf(" Node status: off\n");
   return 0; 
   }

   //shutdown node
   if(ch==6) {
         printf("Shutdown node#%d\n", nr_node);
         if(op_message(nr_node, "H00", out)) {
            op_message(nr_node, "shutdown", out);
            printf("Node#%d, status: %s\n", nr_node, out);
            return 1;
         }
      else printf(" Node status: off\n");
   return 0; 
   }

   //version
   if(ch==7) {
         printf("Version mserverR in node#%d\n", nr_node);
         if(op_message(nr_node, "H00", out)) {
            op_message(nr_node, "version", out);
            printf("number: %s\n", out);
            return 1;
         }
      else printf(" Node status: off\n");
   return 0; 
   }

   //current time
   if(ch==8) {
         printf("Current time in node#%d\n", nr_node);
         if(op_message(nr_node, "H00", out)) {
            op_message(nr_node, "time", out);
            //printf("Time: %s [s] since 0:0:0 GMT\n", out);
            printf("%s\n", out); 
            return 1;
         }
      else printf(" Node status: off\n");
   return 0;     
   }

   //free space HDD
   if(ch==9) {
         printf("Free size HDDs in node#%d\n", nr_node);
         if(op_message(nr_node, "H00", out)) {
            op_message(nr_node, "size", out);
            show_status(nr_node, out);
            return 1;
         }
      else printf(" Node status: off\n");
   return 0;  
   }

   //restart ntpd daemon
   if(ch==10) {
         printf("Restart ndpd in node#%d\n", nr_node);
         if(op_message(nr_node, "H00", out)) {
            op_message(nr_node, "restartntpd", out);
            printf("Node#%d, status restart ntpd: %s\n", nr_node, out);
            return 1;
         }
      else printf(" Node status: off\n");
   return 0; 
   }



   return -1;
}

///////////////////////////////////////////////////////////////////////////////
//------------------------------ END Functions  -------------------------------
///////////////////////////////////////////////////////////////////////////////






void graphic_overlay(void) {

   int ch, k;
   char input[10];

   //all nodes test
   ch = op_all_data_network();
   
   //one node test
   if(ch==-1) {
      printf(" Enter the node number: ");
      fgets(input, 10, stdin);
      ch = atoi(input);
label_begin:
      if(ch==0) {
         printf(RED"\n Error: range of nodes is [1.. 255]\n\n"COLOR_RESET);
         return;
      }
      if(ch>255) {
         printf(RED"\n Error: range of nodes is [1.. 255]\n\n"COLOR_RESET);
         return;
      }

      if(op_one_node(ch)==0) return;
      
      printf("  ...press a key\n");
      k = getch();
      if(k!='q') goto label_begin; else return;
   }
 
}




int main() {

   graphic_overlay();

return 0;
}
