///////////////////////////////////////////////////////////////////////////////
//////////////////// INSTALL watchMYIP and enable service //////////////////////
///////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <termios.h>
#include "select_value.c"

//define ANSI colour in printf
#define BOLDBLACK   "\033[1m\033[30m"
#define BOLDRED     "\033[1m\033[31m"
#define BOLDBLUE    "\033[1m\033[34m"
#define RED     	"\x1b[31m"
#define GREEN   	"\x1b[32m"
#define YELLOW  	"\x1b[33m"
#define BLUE    	"\x1b[34m"
#define MAGENTA 	"\x1b[35m"
#define CYAN    	"\x1b[36m"
#define COLOR_RESET   	"\x1b[0m"


#define SERVICE_NAME "watchMYIP.service"
#define CONFIG_FILE  "watchMYIP.config"





// return pressed key
int getch(void) {
    struct termios oldattr, newattr;
    int ch;
    tcgetattr( STDIN_FILENO, &oldattr );
    newattr = oldattr;
    newattr.c_lflag &= ~( ICANON | ECHO );
    tcsetattr( STDIN_FILENO, TCSANOW, &newattr );
    ch = getchar();
    tcsetattr( STDIN_FILENO, TCSANOW, &oldattr );
    return ch;
}






//creates file watchMYIP.service
int create_UIDC_service_file(const char*fname_service, 
                                const char*user_name) {

   char*line1 = "#autostart watchMYIP";
   char*line2 = "#cp to /etc/systemd/system/watchMYIP.service";
   char*line3 = "#systemctl start watchMYIP";
   char*line4 = "#systemctl enable watchMYIP";
   char*line5 = "#to remove service";
   char*line6 = "#systemctl stop watchMYIP";
   char*line7 = "#systemctl disable watchMYIP";


   char*line8 =  "[Unit]";
   char*line9 =  "Description=watchMYIP daemon";
   char*line10 = "After=network.target";

   char*line11 = "[Service]";
   char*line12 = "Type=forking";
   //char line13[512] = "EnvironmentFile=/home/pi/UIDC-EXEC/MYIP_SERVER/watchMYIP.config";
   char line14[512] = "ExecStart=/home/pi/UIDC-EXEC/MYIP_SERVER/watchMYIP";
   char*line15 = "ExecReload=/bin/kill -HUP $MAINPID"; 
   char*line16 = "KillMode=process";
   char*line17 = "Restart=on-failure";
   char*line18 = "RestartSec=30s";

   char*line19 = "[Install]";
   char*line20 = "WantedBy=multi-user.target";

/*
   strcpy(line13, "EnvironmentFile=/home/");
   strcat(line13, user_name);
   strcat(line13, "/UIDC-EXEC/MYIP_SERVER/watchMYIP.config");
*/

   strcpy(line14, "ExecStart=/home/");
   strcat(line14, user_name);
   strcat(line14, "/UIDC-EXEC/MYIP_SERVER/watchMYIP ");
   strcat(line14, user_name);

   FILE*fd = fopen(fname_service, "w");
   if(fd==NULL) {
      printf(RED"Error: can't open file %s for write\n"COLOR_RESET, 
             fname_service);
      return -1;
   }

   fprintf(fd,"%s\n", line1);
   fprintf(fd,"%s\n", line2);
   fprintf(fd,"%s\n", line3);
   fprintf(fd,"%s\n", line4);
   fprintf(fd,"%s\n", line5);
   fprintf(fd,"%s\n", line6);
   fprintf(fd,"%s\n\n\n", line7);
   fprintf(fd,"%s\n", line8);
   fprintf(fd,"%s\n", line9);
   fprintf(fd,"%s\n\n", line10);
   fprintf(fd,"%s\n", line11);
   fprintf(fd,"%s\n", line12);
   //fprintf(fd,"%s\n", line13);
   fprintf(fd,"%s\n", line14);
   fprintf(fd,"%s\n", line15);
   fprintf(fd,"%s\n", line16);
   fprintf(fd,"%s\n", line17);
   fprintf(fd,"%s\n\n", line18);
   fprintf(fd,"%s\n", line19);
   fprintf(fd,"%s\n", line20);
   
   fclose(fd);
   return 0;
}

/*
//firewall
int open_port(const char*fname_config) {
   char *set_fwld = "sudo ufw allow ";
   char *tcp = "/tcp";
   char *reload = "firewall-cmd --reload";
   char buf[512];
   char port[20];
   char st[80];
  
   FILE*fd = fopen(fname_config, "r");
   if(fd == NULL) return -1;
   while(fgets(buf,512,fd)!=NULL) {
      select_value(buf, "PORTR", st);
      if(strcmp(st,"NULL")!=0) strcpy(port,st);
   }
   fclose(fd);

   strcpy(buf, set_fwld);
   strcat(buf, port);
   strcat(buf, tcp);

   //printf(" Firewall: %s\n", buf);
   system(buf);
   //printf(" Firewall: %s\n", reload);
   system(reload); 
   return 0;  
}
*/




int main(int argc, char**argv) {

   int ch;
   char st[80];
   char*p;


   if(getuid()!=0) {
      printf(RED"Must be root!\n"COLOR_RESET);
      return 0;
   }


   //firewall
  /* printf(" Enable port in firewall\n");
   if(open_port(CONFIG_FILE)==-1) {
      printf(RED" Error: can't read %s\n"COLOR_RESET, CONFIG_FILE);
      return 0;
   }

   printf("\n");
   */

   if(argc==2) {
      if(strlen(argv[1])>40) {
         printf(RED"Error: user name is too long (<40)!\n"COLOR_RESET);
         return 0;
      }
      strcpy(st,argv[1]);
   } 
   else {
      //check user name
      p=getenv("USER");
      if(p==NULL) {
          printf(RED"Error: can't get user name\n"COLOR_RESET);
          return 0;
      }
      strcpy(st,p);
   }

   printf(RED" User name: %s\n"COLOR_RESET, st);
   printf(" Is corretct user name [Y]/N ? ");
   ch = getch();
   printf("\n");
   if(ch=='n' || ch=='N') return 0;
   printf("\n");


   //creates file watchMYIP.service
   create_UIDC_service_file(SERVICE_NAME, st);


   //install watchMYIP.service in /etc/systemd/system/
   printf(" Do you want install service: %s [Y]/N ? ", SERVICE_NAME);
   ch = getch();
   printf("\n");
   if(ch=='n' || ch=='N') {
      //remove file watchMYIP.service
      strcpy(st, "rm -f ");
      strcat(st, SERVICE_NAME);
      system(st);
      return 0;
   }
   strcpy(st, "yes | cp ");
   strcat(st, SERVICE_NAME);
   strcat(st, " /etc/systemd/system/");
   strcat(st, SERVICE_NAME);
   system(st);

   //chmod 644
   strcpy(st, "chmod 644 /etc/systemd/system/");
   strcat(st, SERVICE_NAME);
   system(st);

   //reload daemons
   system("systemctl daemon-reload");

   //systemctl start watchMYIP.service
   strcpy(st, "systemctl start ");
   strcat(st, SERVICE_NAME);
   system(st);
  
   //remove file watchMYIP.service
   strcpy(st, "rm -f ");
   strcat(st, SERVICE_NAME);
   system(st);



   printf("\n");   

   //enable watchMYIP.service 
   printf(" Do you want enable service: %s [Y]/N ? ", SERVICE_NAME);
   ch = getch();
   printf("\n");
   if(ch=='n' || ch=='N') {
      return 0;
   }
   printf("\n");
   strcpy(st, "systemctl enable ");
   strcat(st, SERVICE_NAME);
   system(st);


  
   return 0;
}
