/******************************************************************************
 *
 *
 *				CODER/DECODER
 *
 *  - USER PIN/PASSWD
 *  - UID/SHORT MESSAGES
 *
 *
 *****************************************************************************/



#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <stdint.h>
#include <string.h>
#include <stdlib.h>
#include <sys/time.h>
#include <unistd.h>
#include <time.h>
#include <stdint.h>
#include <sys/ioctl.h>
#include <linux/fs.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <linux/random.h>
//#include <math.h>
#include "genRSA.c"
#include "md5lib.c"


//definiuje ANSI kolory w printf
#define BOLDBLACK   "\033[1m\033[30m"
#define BOLDRED     "\033[1m\033[31m"
#define BOLDBLUE    "\033[1m\033[34m"
#define RED     	"\x1b[31m"
#define GREEN   	"\x1b[32m"
#define YELLOW  	"\x1b[33m"
#define BLUE    	"\x1b[34m"
#define MAGENTA 	"\x1b[35m"
#define CYAN    	"\x1b[36m"
#define COLOR_RESET   	"\x1b[0m"



//defined in confQ.c
//#define HEADSIZE 512  //cuder V1(for uid)
//#define BUFSIZE HEADSIZE+512

unsigned int key = 63542357;//value isn't important
unsigned int old_key = 63542357;




//----------------------------- HARDWARE SEED----------------------------------
//uses /dev/urandom
int dev_urandom(void*buf, size_t len) {
	struct stat st;
	size_t i;
	int fd, cnt, flags;

label_start:
	flags = O_RDONLY;
#ifdef O_NOFOLLOW
	flags |= O_NOFOLLOW;
#endif 
#ifdef O_CLOEXEC
	flags |= O_CLOEXEC;
#endif
	fd = open("/dev/urandom", flags,0);
	if(fd<0) {
		if(errno == EINTR) goto label_start;
		goto label_nodevrandom;
	}
#ifdef O_CLOEXEC
	fcntl(fd, F_SETFD, fcntl(fd, F_GETFD)|FD_CLOEXEC);
#endif
 	//check /dev/urandom
 	if(fstat(fd, &st) == -1 || !S_ISCHR(st.st_mode)) {
		close(fd);
		goto label_nodevrandom;
	}

	if(ioctl(fd, RNDGETENTCNT, &cnt) == -1) {
		close(fd);
		goto label_nodevrandom;
		
	}
	for(i=0; i<len; ) {
		size_t wanted = len - i;
		ssize_t ret = read(fd, (char*)buf+i, wanted);
		if(ret == -1) {
			if(errno == EAGAIN || errno == EINTR)
				continue;
			close(fd);
			goto label_nodevrandom;
		}
		i += ret;	
	}
	close(fd);
	return 0;

label_nodevrandom:
	errno = EIO;
	return -1;
	
} 
//--------------------------- END HARDWARE SEED--------------------------------



//------------------------------ super fast PRND ------------------------------
static unsigned long x=123456789, y=362436069, z=521288629;
unsigned long xorshf96(void) {          //period 2^96-1
unsigned long t;
    x ^= x << 16;
    x ^= x >> 5;
    x ^= x << 1;
   t = x;
   x = y;
   y = z;
   z = t ^ x ^ y;
  return z;
}
//--------------------------- END super fast PRND -----------------------------



//------------------------ KEY_PASS & NOISE GENERATORS ------------------------ 
// --- digial noise strams (dual) ---       
void noise_gen(char*nrnd, int size) {

	union data_ {
	 	unsigned int k;
	 	char txt[4];
	} data;

	char st[40];
	char txt[40];
	char hash[40];
	char rdat[10];

	struct timespec tv;
	unsigned int nhash, nhash1;

    	int k,j;
	
	//get ranom numbers from /dev/urandom
	int ret = dev_urandom((char*)rdat, 4);
	
	//srand for fast prnd
 	if(ret == -1) {
	if( clock_gettime(CLOCK_REALTIME, &tv) < 0) 
		{nhash1 = (unsigned int)time(NULL)+37;}
			else {
				sprintf(txt, "%ld", (long)tv.tv_sec);
				sprintf(st, "%ld", (long)tv.tv_nsec);
				strcat(txt, st);
				md5lib(txt, hash, &nhash1);
			}
	} 
	else {
		*data.txt = *rdat;
		*(data.txt+1) = *(rdat+1);
		*(data.txt+2) = *(rdat+2);
		*(data.txt+3) = *(rdat+3);
		nhash1 = data.k;
	}	
	
	//srand for system prnd (rand())
 	if(ret == -1) {
		if( clock_gettime(CLOCK_REALTIME, &tv) < 0) 
		{srand((unsigned int)time(NULL)+133);}
			else {
				sprintf(txt, "%ld", (long)tv.tv_sec);
				sprintf(st, "%ld", (long)tv.tv_nsec);
				strcat(txt, st);
				md5lib(txt, hash, &nhash);
				srand(nhash);
			}
	} 
	else {
		*(data.txt) = *(rdat+4);
		*(data.txt+1) = *(rdat+5);
		*(data.txt+2) = *(rdat+6);
		*(data.txt+3) = *(rdat+7);
		srand(data.k);
	}
	
	//srand for fast prnd (xorshf96())
	x=123456789, y=362436069, z=521288629;
	//x+=nhash;
	x = nhash1;
	k=0;
	j=1;
    	 do {
		*(nrnd+k) = rand()%255;
		*(nrnd+j) = xorshf96()%255;
		j+=2;
		k+=2;
	} while(j < size);
 }





//key for coder/decoder 
//  seed for RSA_srand changes automatically after 24 hours
//  returns:
//         -1 if time() isn't available and see=19700211
//          0 - correct state
int key_number(unsigned int*seed) {
    
    struct tm *tms;
    time_t tt = time(NULL);
    int y,m,d;

    if(tt==(time_t)-1) {*seed=19700211; return -1;}

    tms = localtime(&tt);

    y = tms->tm_year+1900;
    m = tms->tm_mon;
    d = tms->tm_yday+1;   

    *seed = (unsigned int)(17*(d*123+y*11+m));

    return 0; 
}
//--------------------- END KEY_PASS & NOISE GENERATORS -----------------------








//------------------ PRIVATE USER's PIN/PASSWD CODER/DECODER ------------------

////char uidp[32]  = "EXZ1234567890123456789012345678";
///char euidp[32] = "WXZ84994750p3478[09u34thi8yh04f";
//0-4294967295
//256power(4) = 4294967296 
// buf[4096];
// creation privete user's passwd for MMC/USB
void usb_passwd_gen(const char*user_key, char*buf) {

   char key[256];
   char cover[256];
   int i,j,len,shift;
   char k[2];   

   if(user_key==NULL) {buf[0]='\0'; return;}
   len = (int)strlen(user_key);
   if(len==0)  {buf[0]='\0'; return;}

   if(len>255) {
      memcpy(key,user_key,254);
      key[255]='\0';
   } else strcpy(key,user_key);

   len = (int)strlen(key);

   shift = (4096/len) - 7;
   
   //encapsulation
   RSA_srand(len);
   for(i=0; i<256; i++) cover[i]=RSA_rand()%255;

   //noise
   RSA_srand(time(NULL));
   for(i=0; i<4096; i++) buf[i]=RSA_rand()%255;

   j=0;
   for(i=0; i<len; i++) {
      RSA_srand((unsigned int)key[i]);
      k[0] = (char)(RSA_rand()%255);
      //j+=12;
      j+=shift+abs(k[0]%7);
      buf[j]=k[0]^cover[i];
   } 
}


//check key stored in dongle
//private user's passsd of MMC/USB
//returns:
//      1 - user_key is correct
//      0 - User_key is incorrect
int decode_usb_passwd(const char*user_key, const char*buf) {
   char key[256];
   char cover[256];
   int i,j,len,shift;
   char k[2];
  
   if(user_key==NULL) return 0;
   len = (int)strlen(user_key);
   if(len==0) return 0;
   
   if(len>255) {
      memcpy(key,user_key,254);
      key[255]='\0';
   } else strcpy(key,user_key);

   len = (int)strlen(key);

   shift = (4096/len) - 7;

   RSA_srand(len);
   for(i=0; i<256; i++) cover[i]=RSA_rand()%255;

   j=0;
   for(i=0; i<len; i++) {
      RSA_srand((unsigned int)key[i]);
      k[0] = (char)(RSA_rand()%255);
       j+=shift+abs(k[0]%7);
      if(buf[j]!=(k[0]^cover[i])) return 0;
   }
   return 1;
}
//-------------- END PRIVATE USER's PIN/PASSWD CODER/DECODER ------------------



char key_buf2[HEADSIZE];

void check_key_number(void) {

   key_number(&key);	
   if(old_key == key) {
	 //puts("----eq----"); 
	 return; }

   RSA_srand(key);
   int i; 
   for(i=0; i<HEADSIZE; i++) *(key_buf2+i) = RSA_rand()%255;

   //puts("---- new ---");	

   old_key = key;

}




//---------------------- UID/SHORT MESSAGES CODER -----------------------------
// out size = 2*512;
// limit text size < 512;
void codeV1(const char*text, unsigned int key, char*out) {

   int i,j; 
   
   char key_buf1[HEADSIZE]; //512 bytes
   //char key_buf2[HEADSIZE];
   char text1[HEADSIZE];

   size_t len = strlen(text);
   if(len>HEADSIZE) len=HEADSIZE-1;      //cuts length message to 512 bytes  

   noise_gen(text1, HEADSIZE);
   memcpy(text1, text, len+1);
   
   //key_number(&key); //gets current passwd
   check_key_number();

   noise_gen(key_buf1, HEADSIZE);

   //RSA_srand(key);
   //for(i=0; i<HEADSIZE; i++) *(key_buf2+i) = RSA_rand()%255;

   i=0;j=0;
   while(i<HEADSIZE) {
     *(out+j) = *(text1+i)^*(key_buf1+i);
     *(out+j+1) = *(key_buf1+i)^ *(key_buf2+i);
    i++;
    j+=2;
   }
}


//out size = 2*512;
//limt text size < 512;
void decodeV1(char*out, unsigned int key, char*text) {

   int i,j;
   //char key_buf2[HEADSIZE];
   
   //key_number(&key);
   check_key_number();


   //RSA_srand(key);
   //for(i=0; i<HEADSIZE; i++) *(key_buf2+i) = RSA_rand()%255;

   i=0;j=0;
   while(i<HEADSIZE) {
     *(out+j+1) = *(out+j+1)^ *(key_buf2+i);
     *(text+i) = *(out+j)^*(out+j+1);
    i++;
    j+=2;
   }
}
//---------------------- END UID/SHORT MESSAGES CODER -------------------------
