///////////////////////////////////////////////////////////////////////////////
//
//
//			Instalacja katalogu LIST
//
//
//////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <sys/stat.h>
#include <string.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>
#include "select_value.c"


#define CONFIG_FILE "mserverUIDC.config"


int write_header(const char*filename, const char*str) {
	FILE*fd = fopen(filename,"w");
		if(fd==NULL) {
		printf("can't write header\n");
		return -1;
		}
	fprintf(fd,"%s\n",str);
	fclose(fd);
	return 0;
}



//sprawdza obecnosc katalogu
int chk_folder(const char*folder) {

    struct stat sb;

    if (stat(folder, &sb) == 0 && S_ISDIR(sb.st_mode)) {
        return 1;
    } else {
        return 0;
    }
}


//tworzy katalog LIST
int create_directory(const char*dir) {

	
	char str[256]="";

	
	if(strcmp(dir,"null")==0) {
		strcat(str,"LIST");	
		} else	{
			strcpy(str, "DISK/");
			strcat(str,dir);
			}	  
        umask(0);
	mkdir(str,0777);

	strcat(str, "/name");
	write_header(str, "listUIDC");

	return 0;
}


//wczytuje config z pliku
int read_config_file(char*disk, char *dir) {

	char line[256];
	char str[256] = "null";
	char *p;

	FILE*fd = fopen(CONFIG_FILE, "r");
	if(fd == NULL) return -1;

	while(fgets(line, 128, fd) != NULL) {
	  p = strstr(line, "LISTBASE");
	  if(p != NULL && *line != '#') strcpy(str, line);
	}
	
	fclose(fd);

	select_value(str, "LISTBASE", disk);
	if(strcmp(disk, "NULL") == 0) {
		strcpy(disk, "null");
		return -1;
	}
	
	select_value(str, "DIR", dir);
	if(strcmp(dir, "NULL") == 0) {
		strcpy(dir, "null");
		return -1;
	}


	return 0;	
}


//montuje disk jesli zdefiniowany jest: LISTBASE=/dev/sdb1&DIR=LIST&
//na dysku montowanym
int mmount_disk(const char*disk, const char*dir) {

	char st[256];
        FILE* fp;

	strcpy(st, "mount ");
	strcat(st, disk); 
	strcat(st, " ");
	strcat(st, "DISK");
	fp = popen(st, "r");
	if(fp == NULL) return -1;
	while(fgets(st, 256, fp) != NULL) printf("%s\n", st);
	pclose(fp);
	return 0;
}

//odmontowuje dysk
int umount_disk(const char*disk) {
 	char st[256] = "umount ";
	strcat(st, disk);

	FILE*fp = popen(st, "r");
	if(fp == NULL) return -1;
	pclose(fp);
	return 0;
}


//sprawdza czy partycja istnieje
int check_partition_disk(const char*disk) {

    char*s = "fdisk -l";
    char *p;
    char buf[256];

    FILE*fp = popen(s, "r");
    if(fp == NULL) return -1;

    int ch = 0;
    while(fgets(buf, 256, fp) != NULL) {
	p = strstr(buf, disk);
	if(p != NULL) ch = 1;
    }

 //if(ch) puts("  ------- partition present ----");
 // else puts("  ------- partition not presesent ! ----");

    pclose(fp);
    return ch;
}


//sprawdza czy partycja jest zamontowana
int check_mounted_disk(const char*disk) {

    char*s = "df -h";
    char *p;
    char buf[256];

    FILE*fp = popen(s, "r");
    if(fp == NULL) return -1;

    int ch = 0;
    while(fgets(buf, 256, fp) != NULL) {
	p = strstr(buf, disk);
	if(p != NULL) ch = 1;
    }

    pclose(fp);
    return ch;
}



int main() {

char dir[256];
char disk[256];
char st[256] = "DISK";
int ch;


//LISTBASE=/dev/sdb1&DIR=LIST&
//wczytuje ustawienia z configu
if(read_config_file(disk, dir) < 0) {
	printf("ERROR: cannot instal LIST directory!!!!\n");
	return 0;
}


umask(0);
mkdir("DISK", 0777);

ch = 0;
if(strcmp(disk, "null") != 0) {
	//sprawdza obecnosc partycji deklarowanej w configu
	if(!check_partition_disk(disk)) {
    		printf(" %s in config is not connected!\n", disk);
    		return 0;
	}

	//sprawdza czy partycja jest zamontowana
	if(check_mounted_disk(disk)) umount_disk(disk);


	sleep(1);

	//montuje dysk
	if(strcmp(disk, "null") != 0) mmount_disk(disk, dir);

	ch = 1;
}


strcat(st, "/");
strcat(st, dir);
//sprawdza czy folder jest juz zainstalowany
if(chk_folder(st)) {
	printf("\n INFO: folder LIST is present\n\n");

	//odmontowuje dysk
	if(check_mounted_disk(disk) && ch) umount_disk(disk);
	return 0;
}


//tworzy katalog DISK/LIST
create_directory(dir);


//sprawdza czy folder udalo sie zainstalowac
if(chk_folder(st)) {
	printf("\n INFO: folder LIST has been installed\n\n");
}


sleep(1);


if(strcmp(disk, "null") != 0 && ch) {
	//odmontowuje dysk
	if(check_mounted_disk(disk)) umount_disk(disk);
}

return 0;
}
