///////////////////////////////////////////////////////////////////////////////
//
//			            DAEMON
//			     Synchronizacja czasu 
//			 (ntpdate -u tempus1.gum.gov.pl)       
//				    ver 0.2
//
//
// Uwaga! nalezy otworzyc prt ntp w firewall
//				    
// kompilacja: make
// 
///////////////////////////////////////////////////////////////////////////////


#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <linux/fs.h>
#include "select_value.c"


#define RED   "\x1B[31m"
#define RESET "\x1B[0m"

#define CONFIG_FILENAME "timer.config"
#define MAX_STRING 1024
#define TIMER_ADDR "tempus1.gum.gov.pl"
//#define TIMER_ADDR "0.pool.ntp.org"
char timer_address[256] = TIMER_ADDR;
#define DELAY "1" //1h
char delay_time[256] = DELAY; 
int delay=3600;



//odczytuje dane z pliku konfiguracyjnego
int read_config(void) {

	char*st  = (char*)malloc(MAX_STRING*sizeof(char));
	char*out = (char*)malloc(MAX_STRING*sizeof(char));

	FILE*fd = fopen(CONFIG_FILENAME,"r");
	if(fd==NULL) {free(st); free(out); return -1;}

	while(fgets(st,MAX_STRING,fd)!=NULL) {
	if(st[0]!='#') {
		select_value(st,"TIMERADDR",out);
		if(strcmp(out,"NULL")!=0) strcpy(timer_address,out);
		select_value(st,"DELAY",out);
		if(strcmp(out,"NULL")!=0) strcpy(delay_time,out);
		delay = 3600* atoi(delay_time);	        
		}	
	}
	free(st);
	free(out);
	fclose(fd);
	return 0;
}





//synchronizacja czasu z tempusem1
int trimmer(void){
	int ret;
	int status;
	pid_t pid;
	
	status = fork();
	if(status == 0) {
		ret = execl("/usr/sbin/ntpdate", "ntpdate", "-u", timer_address,NULL);
		printf("RET NTPDTE: %d\n", ret);
	} else if(status != -1) {
		printf("Waiting for the end of addjust time process ...\n\n");
		pid = wait(&status);
		if(pid==-1) return -1;
		} else {
			//printf("Error: fork\n");
			perror("Error calling ntpdate");
		}
	return 0;
}






int main(int argc, char **argv) {

  pid_t pid;
  int i;


  printf("\n       --- Daemon sync time run ---\n\n");	


  //sprawdza czy daemon jest uruchamiany jako root
  if(getuid()!=0) {
		printf(RED"\n  Login as root [1]\n"RESET); 
		return 0;
		}



  i = read_config(); //czyta dane z pliku timer.config



  //delay mozna wprowadzic: sync_time 2 //co 2h
  if(argc==2 && i==-1) {
	i= atoi(argv[1]);

	if(i<1) i=1;
	if(i>24) i=24;
	delay*=i;
	}

  printf("       Sync will be after:   %dh\n",delay/3600);
  printf("       Sync external server: %s\n\n",timer_address);




//		---------- DAEMON ----------

  // --- szkielet demona ---
  pid = fork();
  if(pid==-1) exit(EXIT_FAILURE);//return -1;
  else 
  if(pid!=0) exit(EXIT_SUCCESS);


  //nowa sesja
  if(setsid()==-1) return -1; 
  //zmiana katalogu roboczego aby przy odmotowaniu HDD nie bylo problemu
  if(chdir("/")==-1) return -1; 

  //zamyka pliki
  close(STDIN_FILENO);
  close(STDOUT_FILENO);
  close(STDERR_FILENO);
  // --- Koniec szkieletu demona ---


  //--- tresc daemona ---
  while(1) {
	//synchronizuje zegar systemowy
	trimmer();
	trimmer();
	trimmer();
	//synchronizuje zegar sprzetowy
	//system("hwclock --systohc");
	//usypia proces na delay skund
   	sleep(delay);
  	}
  //--- koniec tresci daemona ---


  return 0;
}
